#ifndef BatchLab_FitFactory_h
#define BatchLab_FitFactory_h

#include <vector> //If AIDA-v3r2p1

#include <AIDA/IFitFactory.h>

namespace AIDA {
  class IFitData;
  class IFitter;
  class IFunctionFactory;
  class ITupleFactory;
}

namespace Slash {namespace Core {class IWriter;}}

namespace BatchLab {

class FitFactory : public virtual AIDA::IFitFactory {
public: //AIDA/IFitFactory
  virtual AIDA::IFitData* createFitData();
  virtual AIDA::IFitter* createFitter(const std::string&,
                                      const std::string&,const std::string&);
  virtual std::vector<std::string> availableFitMethods() const; //AIDA-v3r3p0
  virtual std::vector<std::string> availableFitEngines() const; //AIDA-v3r3p0
public:
  FitFactory(Slash::Core::IWriter&,
             AIDA::IFunctionFactory&,AIDA::ITupleFactory&);
  virtual ~FitFactory();
private:
  Slash::Core::IWriter& fPrinter;
  AIDA::IFunctionFactory& fFunctionFactory;
  AIDA::ITupleFactory& fTupleFactory;
};

}

#endif
