#ifndef BatchLab_XML_AIDA_ML_h
#define BatchLab_XML_AIDA_ML_h

// Inheritance :
#include <Lib/BaseML.h>

#include <BatchLab/Core/BaseTree.h>

#include <BatchLab/XML/RW.h>

namespace BatchLab {class BaseTree;}

namespace BatchLab {

class AIDA_ML : public Lib::BaseML {
public:
  AIDA_ML(Lib::ItemMLFactory&,BaseTree&);
  virtual ~AIDA_ML();
  bool write(Slash::Core::IWriter& writer,
             const std::string& path,
             const Slash::Store::IObject& object);
public:
  virtual bool visitEndElement(Lib::ItemML&,bool&);
private:
  void addReader(const std::string&,XML::Reader,bool=false);
  XML::Reader findReader(const std::string&);
  void addDefaultReaders();
  void addWriter(const std::string&,XML::Writer,bool=false);
  XML::Writer findWriter(const std::string&);
  virtual void addDefaultWriters();
private:
  XML::Readers fReaders;
  XML::Writers fWriters;
  BaseTree& fTree;
};

}

#endif
