/**************************************************************************
 *
 *  This file is part of the Coin GUI binding libraries.
 *  Copyright (C) 1998-2001 by Systems in Motion.  All rights reserved.
 *
 *  The libraries this file is part of is free software; you can
 *  redistribute them and/or modify them under the terms of the GNU
 *  Lesser General Public License version 2.1 as published by the
 *  Free Software Foundation.  See the file LICENSE.LGPL at the root
 *  directory of the distribution for all the details.
 *
 *  If you want to use the Coin GUI binding libraries for applications
 *  not compatible with the LGPL, contact SIM about acquiring a
 *  Professional Edition License.
 *
 *  Systems in Motion, Prof Brochs gate 6, N-7030 Trondheim, NORWAY
 *  http://www.sim.no/ support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
 **************************************************************************/

// 

#ifndef SOWIN_INPUTFOCUS_H
#define SOWIN_INPUTFOCUS_H

#include <Inventor/Win/devices/SoWinDevice.h>

// *************************************************************************

// FIXME: I'm not sure if the X11 enum value matching here is
// necessary or not. Should investigate. 20011211 mortene.
#define sowinEnterWindowMask 0x01 // Matches X11 EnterWindowMask
#define sowinLeaveWindowMask 0x02 // Matches X11 LeaveWindowMask


#define SO_WIN_ALL_FOCUS_EVENTS SoWinInputFocus::ALL_EVENTS;

class SOWIN_DLL_API SoWinInputFocus : public SoWinDevice {
  SOWIN_OBJECT_HEADER(SoWinInputFocus, SoWinDevice);
  

public:
  enum Events {
    ENTER_WINDOW = sowinEnterWindowMask,
    LEAVE_WINDOW = sowinLeaveWindowMask,
    ALL_EVENTS   = sowinEnterWindowMask | sowinLeaveWindowMask
  };

  SoWinInputFocus(int mask = ALL_EVENTS);
  virtual ~SoWinInputFocus(void);

  virtual void enable(HWND widget, SoWinEventHandler * handler,
                      void * closure
#ifdef __COIN_SOXT__ // FIXME: get rid of this abominable #ifdef. 20011229 mortene.
                      , Window window = NULL
#endif // __COIN_SOXT__
                      );
  virtual void disable(HWND widget, SoWinEventHandler * handler,
                       void * closure);

  virtual const SoEvent * translateEvent(MSG * event);

private:
  int eventmask;

}; // class SoWinInputFocus

// *************************************************************************

#endif // ! SOWIN_INPUTFOCUS_H
