@ECHO OFF
SETLOCAL

SET bin=.\

FOR /F "usebackq delims=;" %%s IN (`osc-config --cppflags`) DO SET onx_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`osc-config --libs`) DO SET onx_libs=%%s
FOR /F "usebackq delims=;" %%s IN (`osc-config --iv_cppflags`) DO SET onx_iv_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`osc-config --iv_libs`) DO SET onx_iv_libs=%%s
FOR /F "usebackq delims=;" %%s IN (`osc-config --g3lab_cppflags`) DO SET onx_g3lab_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`osc-config --g3lab_libs`) DO SET onx_g3lab_libs=%%s

REM # /GR to enable RTTI and dynamic cast.
REM # /GX to enable exception handling (for STL).
REM # /O2 optimize
REM # /W3 warmings
SET cppflags=/nologo /DWIN32 /MD /GX /GR /O2 /W3 /I. /I..

REM #//////////////////////////////////////////////////
REM #// dll G3Simple :
REM #//////////////////////////////////////////////////

SET cppflags=%cppflags% %onx_iv_cppflags%
SET cppflags=%cppflags% %onx_cppflags%
SET cppflags=%cppflags% %onx_g3lab_cppflags%

cl.exe /c %cppflags% /Fo%bin%Types.obj /Tp..\source\Types.cxx
f77.exe /nologo /MD /c /Fo%bin%simple.obj ..\source\simple.f
cl.exe /c %cppflags% /Fo%bin%Callbacks.obj /Tp..\source\Callbacks.cxx

SET objs=%bin%\Types.obj %bin%\simple.obj %bin%\Callbacks.obj

SET libs=
SET libs=%libs% %onx_iv_libs%
SET libs=%libs% %onx_libs%
SET libs=%libs% %onx_g3lab_libs%

lib.exe /nologo /machine:ix86 /out:%bin%G3Simple.arc %objs%

REM # Build the win32def.exe utility program :
cl.exe %cppflags% /Fe%bin%win32def.exe /Tpwin32def.c

REM # Building the .def file :
dumpbin /out:%bin%tmp /symbols %bin%G3Simple.arc
%bin%win32def.exe G3Simple < %bin%tmp > %bin%G3Simple.def

REM # Build the DLL :
lib.exe /nologo /machine:ix86 /def:%bin%G3Simple.def /out:%bin%G3Simple.lib
IF EXIST %bin%G3Simple.dll DEL %bin%G3Simple.dll
link.exe /nologo /dll /out:%bin%G3Simple.dll %bin%G3Simple.exp %bin%G3Simple.arc %libs%

del %bin%tmp
del %objs%

del %bin%win32def.obj
del %bin%G3Simple.arc
del %bin%G3Simple.def
del %bin%G3Simple.exp

ENDLOCAL
@ECHO ON
