//
//  All functions here should be OnX callbacks, that is to say
// functions with signature :
//   extern "C" {
//     void callback_without_arguments(IUI&);
//     void callback_with_arguments(IUI&,const std::vector<std::string>&);
//   }
//


// G3Lab::gmanip related code must be in the same DLL 
// because of the F77 COMMONS.
#include <G3Lab/Callbacks.h>

#include <Slash/Tools/F77.h>

#include "Types.h"

#ifdef WIN32
#define simini SIMINI
#define simevt SIMEVT
#define simtri SIMTRI
#else
#define simini simini_
#define simevt simevt_
#define simtri simtri_
#endif

extern "C" {
  void Slash_stdcall simini();
  void Slash_stdcall simevt(int*);
  void Slash_stdcall simtri();
}

extern "C" {

//////////////////////////////////////////////////////////////////////////////
/// G3Simple/scripts/OnX/G3Simple.onx //////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void G3Simple_initialize(Slash::UI::IUI& aUI,const std::vector<std::string>& aArgs) {
  // Should be executed (in a widget create callback) 
  // when the GUI is constructed 
  G3Lab_initialize(aUI,aArgs);

  Slash::Core::ISession& session = aUI.session();

  Slash::Data::IProcessor* da = Slash::accessorManager(session);
  if(da && !da->findAccessor("Event")) {
    da->addAccessor(new G3Simple::EventType(session));
    da->addAccessor(new G3Simple::TOWE_Type(session));
  }

  simini();

  init_VOLU_ids(aUI.session());
}

void G3Simple_next_event(Slash::UI::IUI& aUI){
  simtri();
  aUI.session().setParameter("digi.location","ECAL_TOWE");
  init_EVENT_ids(aUI.session(),true);
  Slash::Data::IProcessor* da = Slash::accessorManager(aUI.session());
  if(da) {
   {Slash::Data::IAccessor* acc = da->findAccessor("TOWE");
    if(acc) {
      G3Simple::TOWE_Type* type = Slash_cast(*acc,G3Simple::TOWE_Type);
      type->fill_ids();
    }}
  }
}

} // extern "C"
