#ifndef G3Lab_gmanip_h
#define G3Lab_gmanip_h

#include <string>
#include <vector>

#define GVOL_VIS_SON_VIS       1        /*Default*/
#define GVOL_INV_SON_VIS       0
#define GVOL_INV_SON_INV      -1
#define GVOL_VIS_SON_INV      -2

#define GFILE_RZ 10
#define GFILE_RA 11
#define GFILE_RX 12
#define GFILE_FZ 20
#define GFILE_FA 21
#define GFILE_FX 22

namespace G3Lab {

class gmanip {
public:
  static void initialize();
  static void loadGeometry(int,const std::string&,int);
  static void saveGeometry(int,const std::string&,int);
  static void readEvent(int);
  static int produceEvent();
  static void clearEvent();
  static std::vector<std::string> volumeNames();
  static void printVolumes();
  static std::string topVolume();
  static std::string volumeName(int);
  static std::string volumeShape(int);
  static int volumeNumed(int);
  static int volumeNumberOfSons(const std::string&);
  static std::string volumeIthSon(const std::string&,int);
  static std::vector<std::string> volumeUpperVolumes(const std::string&);
  static void setVolumeVisibility(const std::string&);
  static void setVolumeDrawingAttribute(const std::string&,const std::string&,int);
  static int volumeDrawingAttribute(const std::string&,const std::string&);
  static bool representVolume(const std::string&,
		       const std::vector<int>&,const std::vector<int>&);
  static int detectorNumberOfHits(const std::string&,const std::string&);
  static bool detectorIthHit(const std::string&,const std::string&,int,
		      std::vector<int>&,std::vector<float>&);
  static void detectorVolumes(const std::string&,const std::string&,
		       std::vector<int>&);
  static int detectorNumberOfDIGIs(const std::string&,const std::string&);
  static bool detectorIthDIGI(const std::string&,const std::string&,int,
		       std::vector<int>&,std::vector<int>&);
  static void representTrack(int,bool);
  static void representVertex(int);
  static int s2h(const std::string&);
  static std::string h2s(int,int = 4);
private:
  static void enableMothers(const std::string&);
};

}

#endif
