
// this :
#include <Primary.h>

// Geant4 :
#include <G4ParticleGun.hh>
#include <G4ParticleTable.hh>
#include <G4ParticleDefinition.hh>

Chunk::PrimaryGeneratorAction::PrimaryGeneratorAction(double a_z,double a_E){
  fParticleGun = new G4ParticleGun(1);
  fParticleGun->SetParticleEnergy(a_E);
  fParticleGun->SetParticleMomentumDirection(G4ThreeVector(0,0,1));
  fParticleGun->SetParticlePosition(G4ThreeVector(0*cm,0*cm,a_z));
  G4ParticleTable* particleTable = G4ParticleTable::GetParticleTable();
  if(!particleTable) {
    G4cout << "Chunk::PrimaryGeneratorAction::PrimaryGeneratorAction :"
           << " G4ParticleTable::GetParticleTable() returned 0 !!!" 
           << std::endl;
    return;
  }
  G4ParticleDefinition* particle = particleTable->FindParticle("e-");
  if(!particle) {
    G4cout << "Chunk::PrimaryGeneratorAction::PrimaryGeneratorAction :"
           << " can't find e-." 
           << std::endl;
    int number = particleTable->size();
    G4cout << "Chunk::PrimaryGeneratorAction::PrimaryGeneratorAction :"
           << " known particles (" << number << ") :"
           << std::endl;
    for(int index=0;index<number;index++) {
      G4cout << "   " << particleTable->GetParticleName(index) << std::endl;
    }
    return;
  }
  fParticleGun->SetParticleDefinition(particle);
}
Chunk::PrimaryGeneratorAction::~PrimaryGeneratorAction(){
  delete fParticleGun;
}
void Chunk::PrimaryGeneratorAction::GeneratePrimaries(G4Event* aEvent){
  fParticleGun->GeneratePrimaryVertex(aEvent);
}

