
// this :
#include <SteppingAction.h>

// AIDA :
#include <AIDA/IAnalysisFactory.h>
#include <AIDA/ITreeFactory.h>
#include <AIDA/ITree.h>
#include <AIDA/IHistogramFactory.h>
#include <AIDA/IHistogram1D.h>
#include <AIDA/IHistogram2D.h>
#include <AIDA/IProfile1D.h>
#include <AIDA/ITupleFactory.h>
#include <AIDA/ITuple.h>

// Geant4 :
#include <G4Step.hh>

// Chunk :
#include <Analysis.h>
#include <Detector.h>

Chunk::SteppingAction::SteppingAction(
 Analysis& aAnalysis
,Detector& aDetector
,double aRhoMoliere
)
:fAnalysis(aAnalysis)
,fDetector(aDetector)
,fRhoMoliere(aRhoMoliere)
{}

Chunk::SteppingAction::~SteppingAction(){}

void Chunk::SteppingAction::UserSteppingAction(
 const G4Step* aStep
) {
  G4double edp = aStep->GetTotalEnergyDeposit();

  fAnalysis.f_dE += edp;

  G4StepPoint* point = aStep->GetPreStepPoint();
  const G4ThreeVector& pos = point->GetPosition();
  G4VPhysicalVolume* PV = point->GetTouchableHandle()->GetVolume();
  if(PV!=fDetector.chunck_PV()) return;

  G4double z = pos.z();
  //if(z<0) return;
  //if(z>fDetector.z()) return;

  double radlen = fDetector.radiation_length();
  double z_fill = z/radlen;
  
  fAnalysis.f_z->fill(z_fill);
  fAnalysis.f_z_dE->fill(z_fill,edp);

  G4double x = pos.x();
  G4double y = pos.y();
  G4double r = ::sqrt(x*x+y*y);
  double r_fill = r/fRhoMoliere;
  
  fAnalysis.f_r->fill(r_fill);
  fAnalysis.f_r_dE->fill(r_fill,edp);

  fAnalysis.f_z_dE_r_dE->fill(z_fill,r_fill,edp);

  //fAnalysis.f_tuple->fill(0,z/cm);
  //fAnalysis.f_tuple->fill(1,edp);
  //fAnalysis.f_tuple->addRow();
}

