
#include "G4RunManager.hh"

#include "Detector.hh"
#include "PhysicsList.hh"
#include "PrimaryGeneratorAction.hh"
//#include "SteppingAction.h"

#ifdef G4UI_USE_OSC
#include <G4Lab/UIOnX.h>
#endif

int main(int argc,char** argv)
{  
  G4RunManager* runManager = new G4RunManager;

  Detector* detector = new Detector;
  runManager->SetUserInitialization(detector);
  runManager->SetUserInitialization(new PhysicsList);
  runManager->SetUserAction(new PrimaryGeneratorAction);
  //runManager->SetUserAction(new SteppingAction());

  runManager->Initialize();
      
#ifdef G4UI_USE_OSC
  std::string GUI = "main.onx";
  G4UIsession* session = new G4Lab::UIOnX(*runManager,GUI,argc,argv);
  session->SessionStart();
  delete session;     
#endif

  delete runManager;

  return 0;
}
