// this :
#include "MagneticField.hh"

// Geant4 :
#include "G4FieldManager.hh"
#include "G4TransportationManager.hh"

//#include "G4Mag_UsualEqRhs.hh"
//#include "G4HelixExplicitEuler.hh"
//#include "G4ChordFinder.hh"
//#include "G4HelixImplicitEuler.hh"
//#include "G4HelixSimpleRunge.hh"

//#include "math.h"

MagneticField::MagneticField() {
  G4FieldManager* fieldMgr = 
    G4TransportationManager::GetTransportationManager()->GetFieldManager();
  fieldMgr->SetDetectorField(this);
  fieldMgr->CreateChordFinder(this);

  // The below are parameters to play with
  // but not needed to see e-, mu-, proton looping !
  //fieldMgr->GetChordFinder()->SetDeltaChord(0.001*mm);
    
  //G4double minEps= 1.0e-4; //    Minimum & value for smallest steps
  //G4double maxEps= 1.0e-3; //    Maximum & value for largest steps
  //fieldMgr->SetMinimumEpsilonStep( minEps );
  //fieldMgr->SetMaximumEpsilonStep( maxEps );
  //fieldMgr->SetDeltaOneStep( 0.5e-3 * mm ); // 0.5 micrometer

  //G4Mag_UsualEqRhs* equation = new G4Mag_UsualEqRhs(this);
    
  //G4HelixImplicitEuler *stepper = new G4HelixImplicitEuler(equation);
  //G4HelixExplicitEuler *stepper = 
  //new G4HelixExplicitEuler(equation);
  //G4HelixSimpleRunge *stepper = new G4HelixSimpleRunge(equation);
 
  //G4cout << "MagneticField::MagneticField()" << G4endl;
}

MagneticField::~MagneticField(){}

void MagneticField::GetFieldValue(const double Point[4],double *Bfield) const {
 
  //G4double hsz = 2*m;
  G4double hsz = 25*cm;

  // 1 tesla = 10 000 gauss

  //::printf("debug : %g %g %g\n",Point[0],Point[1],Point[2]);
  if(std::abs(Point[0])<hsz && 
     std::abs(Point[1])<hsz && 
     std::abs(Point[2])<hsz){
    Bfield[0] = 0.*tesla;
    Bfield[1] = 0.*tesla;
    Bfield[2] = 1*tesla;
  } else {
    Bfield[0] = 0.0;
    Bfield[1] = 0.0;
    Bfield[2] = 0.0;
  }
}
