#ifndef HEPVis_SoGLUT_Viewer_h
#define HEPVis_SoGLUT_Viewer_h

// inheritance :
#include <Inventor/GLUT/viewers/SoGLUT_Viewer.h>

class SoRegion;
class SoFormRegion;

namespace HEPVis {

class SoGLUT_Viewer : public ::SoGLUT_Viewer {
public:
  virtual SbBool processKeyboard(unsigned char,SbBool&);
  virtual SbBool processSpecial(int,SbBool&);
public:
  SoGLUT_Viewer(SoGLUT_Widget* aWidget);
  virtual ~SoGLUT_Viewer();
public:
  void setShootRegion(SoRegion*);
  void setOptionsRegion(SoFormRegion*);
  SoRegion* optionRegion() const;
  SoRegion* shootRegion() const;
private:
  SbBool showUI(SbBool& aRender);
  void nextUI();
  void prevUI();
  SbBool activateUI();
  SbBool showShoot(SbBool& aRender);
  SbBool shoot(SbBool& aRender);
private:
  SoRegion* fShootRegion;
  SoFormRegion* fUI;
  int fUI_current;
  SbBool fJoy_state;
};

}

#endif
