#ifndef HEPVis_SDL_app_h
#define HEPVis_SDL_app_h 

#include <Inventor/SDL/app.h>

inline void hepvis_keyboardCB(void* aTag,SoEventCallback* aEventCB){
  if(aEventCB->isHandled()) return;
  const SoKeyboardEvent* event = (SoKeyboardEvent*)aEventCB->getEvent();
  if(SO_KEY_PRESS_EVENT(event,M)) {
    GameViewer* viewer = (GameViewer*)SoSDL::getTopLevelWidget()->getViewer();
    SbBool render;
    viewer->showUI(render);
    if(render) SoSDL::setViewerRender();
    aEventCB->setHandled();
    return;
  } else if(SO_KEY_PRESS_EVENT(event,R)) {
    GameViewer* viewer = (GameViewer*)SoSDL::getTopLevelWidget()->getViewer();
    SbBool render;
    viewer->showShoot(render);
    if(render) SoSDL::setViewerRender();
    aEventCB->setHandled();
    return;
  } else if(SO_KEY_PRESS_EVENT(event,RETURN)) {
    GameViewer* viewer = (GameViewer*)SoSDL::getTopLevelWidget()->getViewer();
    SbBool render;
    viewer->activate(TRUE,render);
    if(render) SoSDL::setViewerRender();
    aEventCB->setHandled();
    return;
  } else if(SO_KEY_RELEASE_EVENT(event,RETURN)) {
    GameViewer* viewer = (GameViewer*)SoSDL::getTopLevelWidget()->getViewer();
    SbBool render;
    viewer->activate(FALSE,render);
    if(render) SoSDL::setViewerRender();
    aEventCB->setHandled();
    return;
  } else if( SO_KEY_PRESS_EVENT(event,RIGHT_ARROW) ||
             SO_KEY_PRESS_EVENT(event,D)           ){
    GameViewer* viewer = (GameViewer*)SoSDL::getTopLevelWidget()->getViewer();
    if(viewer->uiVisible()) { //move in menu.
      viewer->nextUI();
      SoSDL::setViewerRender();
      aEventCB->setHandled();
      return;
    }
  } else if( SO_KEY_PRESS_EVENT(event,LEFT_ARROW) ||
             SO_KEY_PRESS_EVENT(event,A)           ){
    GameViewer* viewer = (GameViewer*)SoSDL::getTopLevelWidget()->getViewer();
    if(viewer->uiVisible()) { //move in menu.
      viewer->prevUI();
      SoSDL::setViewerRender();
      aEventCB->setHandled();
      return;
    }
  }
  keyboardCB(aTag,aEventCB);  
}
static void hepvis_joyAxisCB(void* aTag,SoEventCallback* aEventCB){
  if(aEventCB->isHandled()) return;
  const SoJoyAxisEvent* event = (SoJoyAxisEvent*)aEventCB->getEvent();
  JoyTag* tag = (JoyTag*)aTag;
  //printf("debug : joy_CB\n");
  if(event->getState()==SoJoyAxisEvent::RIGHT) {
    GameViewer* viewer = (GameViewer*)SoSDL::getTopLevelWidget()->getViewer();
    if(viewer->uiVisible()) { //move in menu.
      viewer->nextUI();
      SoSDL::setViewerRender();
      aEventCB->setHandled();
      return;
    }
  } else if(event->getState()==SoJoyAxisEvent::LEFT) {
    GameViewer* viewer = (GameViewer*)SoSDL::getTopLevelWidget()->getViewer();
    if(viewer->uiVisible()) { //move in menu.
      viewer->prevUI();
      SoSDL::setViewerRender();
      aEventCB->setHandled();
      return;
    }
  }
  joyAxisCB(aTag,aEventCB);  
}

#endif
