#ifndef HEPVis_SoGC_h
#define HEPVis_SoGC_h

// GC is for Graphical Context.

// Inheritance :
#include <HEPVis/SbStyle.h>

class SbPolyhedron;
class SoSeparator;
class SoStyleCache;
class SoHighlightMaterial;
class SoLightModel;
class SoDrawStyle;
class SoPolyhedron;
class SoShapeCache;

class SoGC : public SbStyle {
public:
  SoGC();
  virtual ~SoGC();
  void clear();
  virtual void reset();
  SoHighlightMaterial* getHighlightMaterial();
  SoLightModel* getLightModel();
  SoDrawStyle* getDrawStyle();
  void setSeparator(SoSeparator*);
  SoSeparator* getSeparator() const;
  void setStyleCache(SoStyleCache*);
  SoStyleCache* getStyleCache() const;
  void setLocalSetup(SbBool);
  SbBool getLocalSetup() const;
  SbPolyhedron* getShapeCut();
  SoPolyhedron* getPolyhedron(const SbPolyhedron&);
  void setDefaultStyleCache();
private:
  SoSeparator* fSeparator;
  SoStyleCache* fStyleCache;
  SbBool fLocalSetup;
  SbBool fShapeCutDone;
  SbPolyhedron* fShapeCut;
  SoShapeCache* fShapeCache;
};

#endif
