#ifndef Lib_Expression_h
#define Lib_Expression_h

#include <string>
#include <vector>

#include <Lib/Value.h>

namespace Lib {class IExpFunc;}

namespace Lib {

class Expression {
public:
  enum eType {
    GT = 1,
    GE = 2,
    LT = 3,
    LE = 4,
    EQ = 5,
    NE = 6,
    ADD = 7,
    MUL = 8,
    SUB = 9,
    DIV = 10,
    AND = 11,
    OR = 12,
    ASSIGN = 13,
    MINUS = 14,
    UNSIGNED_INTEGER = 15,
    REAL = 16,
    NAME = 17,
    STRING = 18,
    PI = 19,
    FUNC = 20,
    BOOL_TRUE = 21,
    BOOL_FALSE = 22,
    NOT = 23
  };
public:
  Expression(eType);
  Expression(eType,Expression*);
  Expression(eType,Expression*,Expression*);
  Expression(eType,Lib::IExpFunc*,Expression*);
  Expression(eType,Lib::IExpFunc*,Expression*,Expression*);
  Expression(eType,Lib::IExpFunc*,Expression*,Expression*,Expression*);
  Expression(eType,Lib::IExpFunc*,Expression*,Expression*,Expression*,Expression*);
  Expression(eType,Lib::IExpFunc*,Expression*,Expression*,Expression*,Expression*,Expression*);
  Expression(eType,Lib::IExpFunc*,Expression*,Expression*,Expression*,Expression*,Expression*,Expression*);
  Expression(eType,unsigned int);
  Expression(eType,double);
  Expression(eType,const std::string&);
  Expression(eType,const std::string&,int);
  virtual ~Expression();
  //void print(Slash::Core::IWriter&);
  bool execute(const std::vector<Lib::Value>&,std::string&);
  Lib::Value& ret();
private:
  eType fType;
  Lib::IExpFunc* fFunction;
  Lib::Value fVariable;
  Lib::Value fReturn;
  std::string fName;
  int fIndex;
  //Below, can't have objects of same class than the class.
  Expression* fA; 
  Expression* fB;
  Expression* fC;
  Expression* fD;
  Expression* fE;
  Expression* fF;
};

}

#endif



