
#include <Slash/Core/ISession.h>

//#include <Slash/Tools/UI.h>
#include <Slash/Tools/Inventor.h>
#include <Slash/Tools/IvNet.h>

#include <HEPVis/nodekits/SoPage.h>
#include <HEPVis/nodekits/SoRegion.h>
#include <HEPVis/nodekits/SoDetectorExample.h>

static void detector_visualize(Slash::Core::ISession& a_session,std::ostream& a_out,const std::string& a_viewer,bool a_ui) {

  Slash::UI::IUI* ui = Slash::find_UI(a_session);     
  if(!ui) {
    a_out << "Slash::UI::IUI not found." << std::endl;
    return;
  }

  SoPage* soPage = Slash::find_SoPage(*ui,a_viewer);
  if(!soPage) return;
  soPage->title.setValue("OnX/Detector");

  SoRegion* soRegion = soPage->currentRegion();
  if(!soRegion) return;

  SoDetectorExample* det = new SoDetectorExample();

  if(!Slash::add_scene(*ui,*soRegion,det,a_viewer,"staticScene")) 
    det->unref();

  if(a_ui) ui->steer();

}

#include <Slash/Core/ISession.h>
#include <Slash/Tools/osc_env.h> //For TTFPATH

#include <iostream>

int main(int,char*[]) {

  if(!Slash::osc::set_env(std::cout)) {
    std::cout << "create_ui :"
              << " unable to set OSC environment." << std::endl;
    return 1;
  }

  int argc = 1;
  static char* argv[] = {(char*)"-onx_file=detector.onx"};  

  Slash::Core::ISession* session = Slash_create_session(Slash::to(argc,argv));
  if(!session) {
    std::cout << "detector_visualize :"
              << " session not found." << std::endl;
    return 1;
  }

  detector_visualize(*session,std::cout,"@current@",true);
  delete session;

  return 0;
}
