#ifndef OnX_QtTools_h
#define OnX_QtTools_h 

#include <string>
#include <vector>

namespace Slash {namespace Core {class IWriter;}}

#include <QtCore/qnamespace.h>

class QString;
class QWidget;
class QComboBox;
class QDialog;
class QTabWidget;

class QAbstractButton;
class OnX_Q3HBox;
class OnX_Q3VBox;
class QTreeWidget;
class QTreeWidgetItem;

namespace OnX {

Qt::WFlags decorationFlags(const std::vector< std::pair<bool,std::string> >&,
                           Slash::Core::IWriter&);
int QWidgetGetNumberOfChildren(QWidget&);
void QWidgetSetForeground(QWidget&,const std::string&);
void QWidgetSetBackground(QWidget&,const std::string&);

void QComboBoxSetBackground(QComboBox&,const std::string&);
void QComboBoxSetItems(QComboBox&,const std::vector<std::string>&);
std::vector<std::string> QComboBoxGetItems(QComboBox&);
void QComboBoxSetValue(QComboBox&,const std::string&);
std::string QComboBoxGetValue(QComboBox&);

void QOptionMenuInitialize(QComboBox&,const std::vector<std::string>&,const std::string&);
std::vector<std::string> QOptionMenuGetItems(QComboBox&);
bool QOptionMenuSetDefault(QComboBox&,const std::string&);
std::string QOptionMenuGetValue(QComboBox&);

void QButtonSetBackground(QAbstractButton&,const std::string&);
bool QHBoxSetExpand(OnX_Q3HBox&,const std::string&);
bool QVBoxSetExpand(OnX_Q3VBox&,const std::string&);
std::string QTreeWidgetItemGetPath(QTreeWidgetItem&);
std::string QTreeWidgetItemGetXML(QTreeWidgetItem&);

void QTreeWidgetClear(QTreeWidget&);
std::string QTreeWidgetGetSelection(QTreeWidget&);
bool QTreeWidgetSetSelection(QTreeWidget&,const std::string&);

void QDialogDisableEnter(QDialog&);

bool QTabWidgetSetSelection(QTabWidget&,const std::string&);

}

#endif

