#ifndef Slash_app_h
#define Slash_app_h

#include "smanip.h"
#include "system.h"
#include "directory.h"

namespace Slash {

inline bool is_mac_app(const std::string& a_arg0,std::ostream& a_out,bool& a_is){
#ifdef __APPLE__
  if(a_arg0.empty()) {
    a_is = false;
    return true;
  }
  std::string bname = base_name(dir_name(a_arg0));
  if(bname=="MacOS") {
    a_is = true;
  } else {
    a_is = false;
  }
  return true;
#else
  a_is = false;
  return true;
#endif
}

inline bool if_mouse_startup(const std::string& a_arg0,const std::string& a_pack,std::ostream& a_out){
  std::string app_dir = dir_name(a_arg0);
  std::string bname = base_name(app_dir);
  if(bname=="MacOS") {
    // Avoid polluting the / directory :
    if(!directory::cd_home()) {
      a_out << "if_mouse_startup : can't go home." << std::endl;
      return false;
    } else if(!directory::mkcd("OpenScientist")) {
      a_out << "if_mouse_startup : can't mkcd OpenScientist." << std::endl;
      return false;
    } else if(!directory::mkcd(a_pack)) {
      a_out << "if_mouse_startup :" 
            << " can't mkcd " << a_pack << " ." << std::endl;
      return false;
    } else if(!directory::mkcd("session")) {
      a_out << "if_mouse_startup : can't mkcd session." << std::endl;
      return false;
    } else {
      // mkcds ok.
    }

    // set OSC_HOME_DIR from app_dir :
    std::string OSC_HOME_DIR = Slash::dir_name(app_dir);
    if(!Slash::putenv("OSC_HOME_DIR",OSC_HOME_DIR)) {
      a_out << "if_mouse_startup :"
            << " can't putenv OSC_HOME_DIR to " << Slash::sout(OSC_HOME_DIR)
            << "."
            << std::endl;
      return false;
    }

    if(!Slash::env_path_append("DYLD_LIBRARY_PATH",OSC_HOME_DIR+"/bin"))
      return false;
    // for on-the-fly compilation and loading :
    if(!Slash::env_path_append("DYLD_LIBRARY_PATH",".")) return false;

    if(!Slash::isenv("DISPLAY")) {
      if(!Slash::putenv("DISPLAY",":0.0")) return false;
    }

  } else if(bname=="bin") {
    //Linux, Windows : mouse startup ?
  }

  return true;
}

}

#endif
