#ifndef Slash_fmanip_h
#define Slash_fmanip_h

#include <string>
#include <cstdlib>
#include <cstdio>
#include <sstream>

#include <sys/stat.h>

#ifdef WIN32
#include <process.h>
#else
#include <unistd.h>
#endif

namespace Slash {

inline bool tmpname(const std::string& a_dir,const std::string& a_prefix,const std::string& a_suffix,std::string& a_name){
  //  a_dir must finish with the system path separator.
  std::string head;
  if(a_dir==".") {
  } else if(a_dir.size()) {
    head += a_dir;
  } else {
#ifdef WIN32
    char* env = ::getenv("HOMEDRIVE");
    std::string drive = (env? env : std::string("C:"));
    head += drive;
    head += "\\";
#else
    head += "/tmp/";
#endif
  }
  head += a_prefix;
  char spid[128];
  ::sprintf(spid,"%d",::getpid());
  head += spid;
  head += "_";

  for(int count=0;count<1000;count++) {
    std::ostringstream strm;
    strm.fill('0');
    strm.width(3);
    strm << count;
    std::string tmpnm = head;
    tmpnm += strm.str();
    tmpnm += a_suffix;
    struct stat finfo;
    if(::stat(tmpnm.c_str(),&finfo) < 0) {
      // No directory or file found :
      a_name = tmpnm; // Good file name.
      return true; 
    }
  }
  // No good name found :
  a_name = "";
  return false;
}

}

#endif
