#ifndef oroot_DLL_h
#define oroot_DLL_h

#include <string>
#include <ostream>

namespace oroot {

class DLL {
public:
  static bool is_valid(const std::string&,std::ostream&);
public:
  DLL(const std::string&,std::ostream&,int = 0,bool = false);
  virtual ~DLL();
private:
  DLL(const DLL&);
  DLL& operator=(const DLL&);
public:
  bool open();
  typedef void (*procedure)();
  procedure find(const std::string&,bool quiet = false) const;
  const std::string& file_name() const;
  bool is_opened() const;
protected:
  void* m_module;
  std::ostream& m_out;
  std::string m_name;
  std::string m_DLL;
  int m_verb;
  std::string m_error;
};

}

#endif




