#ifndef oroot_mem_h
#define oroot_mem_h

#include <string>
#include <ostream>

namespace oroot {

class mem {
public:
  static void inc(const char*);
  static void dec(const char*);
  static void inc(const std::string&);
  static void dec(const std::string&);
  static void balance(std::ostream&);
  static void check_class(bool);
  static bool check_class();
};

}


#define oroot_mem_check

#ifdef oroot_mem_check
#define mem_inc(a_class) oroot::mem::inc(a_class)
#define mem_dec(a_class) oroot::mem::dec(a_class)
#else
#define mem_inc(a_class)
#define mem_dec(a_class)
#endif

#endif
